%define lib_major 0
%define lib_name %mklibname %{name}-private %{lib_major}
%define startup_notification_version 0.4

%define libcm_version 0.1.1

Summary: Metacity window manager
Name: metacity
Version: 2.18.0
Release: %mkrel 3
URL: http://ftp.gnome.org/pub/gnome/sources/metacity/
Source0: http://ftp.gnome.org/pub/GNOME/sources/metacity/%{name}-%{version}.tar.bz2
Source1: Wonderland-metacity-0.47.tar.bz2
Source2: http://download.gnome.org/sources/libcm/libcm-%{libcm_version}.tar.bz2
# (fc) 2.3.987-2mdk use Ia Ora as default theme
Patch2: metacity-2.15.21-defaulttheme.patch
# (fc) 2.15.3-1mdv build with static libcm (Fedora)
Patch3: metacity-2.15.3-static-cm.patch
# (fc) 2.18.0-2mdv fix rounded corners (GNOME bug #399373)
Patch4: metacity-2.18.0-fixroundcorner.patch
# (fc) 2.18.0-3mdv fix session hang (SVN) (GNOME bug#407981)
Patch5: metacity-2.18.0-fixsessionhang.patch

License: GPL
Group: Graphical desktop/GNOME
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: libglade2.0-devel
BuildRequires: libGConf2-devel >= 1.1.9
BuildRequires: startup-notification-devel >= %{startup_notification_version}
BuildRequires: libxcomposite-devel
BuildRequires: libxdamage-devel
BuildRequires: libxtst-devel
BuildRequires: libmesaglu-devel
#gw for the broken intltool scripts
BuildRequires: perl-XML-Parser
BuildRequires: GConf2
BuildRequires: intltool

%description
Metacity is a simple window manager that integrates nicely with 
GNOME 2.

%package -n %{lib_name}
Summary:        Libraries for Metacity
Group:          System/Libraries

%description -n %{lib_name}
This package contains libraries used by Metacity.

%package -n %{lib_name}-devel
Summary:        Libraries and include files with Metacity
Group:          Development/GNOME and GTK+
Requires:       %name = %{version}
Requires:		%{lib_name} = %{version}
Provides:		%{name}-devel = %{version}-%{release}
Provides:		lib%{name}-private-devel = %{version}-%{release}

%description -n %{lib_name}-devel
This package provides the necessary development libraries and include 
files to allow you to develop with Metacity.


%prep
%setup -q
%setup -q -D -T -a2
%patch2 -p1 -b .defaulttheme
%patch3 -p1 -b .static-cm
%patch4 -p1 -b .fixroundcorner
%patch5 -p1 -b .sessionhang

#needed by patch3
aclocal
autoconf
automake -a -c

%build

cd libcm-%{libcm_version}
%configure2_5x
%make
make install DESTDIR="$PWD/prefix"
cd ..

LIBS="$LIBS -lGL -lGLU"
LIBS="$LIBS -lICE -lSM"
LIBS="$LIBS -lX11 -lXext -lXinerama -lXrandr"
LIBS="$LIBS -lXrender -lXcursor"
LIBS="$LIBS -lXdamage -lXtst -lXfixes -lXcomposite"
%ifnarch s390 s390x ppc64
LIBS="$LIBS $PWD/libcm-%{libcm_version}/prefix/%{_libdir}/libcm.a"
%endif
export LIBS

CPPFLAGS="-I$PWD/libcm-%{libcm_version}/prefix/%{_includedir}"
export CPPFLAGS


%configure2_5x --enable-compositor
%make 

%install
rm -rf $RPM_BUILD_ROOT

GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1 %makeinstall_std

mkdir -p $RPM_BUILD_ROOT%{_datadir}/themes/Wonderland/metacity-1
tar -xjf %{SOURCE1} -C $RPM_BUILD_ROOT%{_datadir}/themes/Wonderland/metacity-1

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%define schemas metacity

%post
if [ ! -d %{_sysconfdir}/gconf/gconf.xml.local-defaults/apps/metacity/general -a "x$META_CLASS" != "x" ]; then
 case "$META_CLASS" in
  *server) METACITY_THEME="Ia Ora Gray" ;;
  *desktop) METACITY_THEME="Ia Ora Orange" ;;
  *download) METACITY_THEME="Ia Ora Free";;
 esac

  if [ "x$METACITY_THEME" != "x" ]; then 
  %{_bindir}/gconftool-2 --config-source=xml::/etc/gconf/gconf.xml.local-defaults/ --direct --type=string --set /apps/metacity/general/theme "$METACITY_THEME" > /dev/null
  fi
fi
%post_install_gconf_schemas %{schemas}

%preun
%preun_uninstall_gconf_schemas %{schemas}

%post -n %{lib_name} -p /sbin/ldconfig

%postun -n %{lib_name} -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root)
%doc README COPYING NEWS HACKING 
%{_sysconfdir}/gconf/schemas/*
%{_bindir}/*
%{_libexecdir}/metacity-dialog
%{_datadir}/gnome/wm-properties/*
%{_datadir}/metacity
%{_datadir}/themes/*
%{_mandir}/man1/*

%files -n %{lib_name}
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc ChangeLog
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/*.la
%{_includedir}/*
%{_libdir}/pkgconfig/*


%changelog
* Tue Mar 27 2007 Frederic Crozat <fcrozat@mandriva.com> 2.18.0-3mdv2007.1
+ Revision: 149095
- Patch5 (SVN): fix session hang (GNOME bug #407981)

* Thu Mar 22 2007 Frederic Crozat <fcrozat@mandriva.com> 2.18.0-2mdv2007.1
+ Revision: 148024
-Patch4 (CVS): fix rounder corners (GNOME bug #399373)

* Tue Mar 13 2007 Götz Waschk <waschk@mandriva.org> 2.18.0-1mdv2007.1
+ Revision: 142147
- new version
- fix build

  + Thierry Vignaud <tvignaud@mandriva.com>
    - no need to package big ChangeLog when NEWS is already there

* Tue Feb 27 2007 Götz Waschk <waschk@mandriva.org> 2.17.8-1mdv2007.1
+ Revision: 126210
- new version

* Tue Jan 16 2007 Götz Waschk <waschk@mandriva.org> 2.17.5-1mdv2007.1
+ Revision: 109607
- new version
- libcm 0.1.1

* Sat Jan 06 2007 Götz Waschk <waschk@mandriva.org> 2.17.3-2mdv2007.1
+ Revision: 104750
- new libcm

* Mon Dec 11 2006 Götz Waschk <waschk@mandriva.org> 2.17.3-1mdv2007.1
+ Revision: 94729
- new version

* Mon Nov 27 2006 Götz Waschk <waschk@mandriva.org> 2.17.2-1mdv2007.1
+ Revision: 87631
- new version
- unpack patches
- Import metacity



* Wed Oct  4 2006 Gtz Waschk <waschk@mandriva.org> 2.16.3-1mdv2007.0
- drop patches 4,5
- New version 2.16.3

* Tue Sep 19 2006 Frederic Crozat <fcrozat@mandriva.com> 2.16.1-4mdv2007.0
- Oops, Ia Ora Yellow is no more, should be Ia Ora Orange

* Thu Sep 14 2006 Frederic Crozat <fcrozat@mandriva.com> 2.16.1-3mdv2007.0
- Patch5 (CVS): fix window flashing/flickering (GNOME bug #332385)

* Wed Sep 13 2006 Frederic Crozat <fcrozat@mandriva.com> 2.16.1-2mdv2007.0
- Patch4 (CVS): 64bits fixes (GNOME bug #348308)

* Tue Sep 12 2006 Gtz Waschk <waschk@mandriva.org> 2.16.1-1mdv2007.0
- drop patch 4
- New version 2.16.1

* Sun Sep 10 2006 Frederic Crozat <fcrozat@mandriva.com> 2.16.0-2mdv2007.0
- Patch4 (Elijah): fix bad focus assignation (GNOME bug #354422)

* Mon Sep 04 2006 Götz Waschk <waschk@mandriva.org> 2.16.0-1mdv2007.0
- New release 2.16.0

* Tue Aug 22 2006 Götz Waschk <waschk@mandriva.org> 2.15.34-1mdv2007.0
- New release 2.15.34

* Thu Aug 10 2006 Frederic Crozat <fcrozat@mandriva.com> 2.15.21-2mdv2007.0
- Update patch2 to use Ia Ora Blue theme as default
- add post magic to register theme based on meta_class
- use more macros

* Tue Aug 08 2006 Götz Waschk <waschk@mandriva.org> 2.15.21-1mdv2007.0
- New release 2.15.21

* Tue Jul 25 2006 Götz Waschk <waschk@mandriva.org> 2.15.13-1
- New release 2.15.13

* Tue Jul 11 2006 Götz Waschk <waschk@mandriva.org> 2.15.8-1mdv2007.0
- New release 2.15.8

* Tue Jun 13 2006 Frederic Crozat <fcrozat@mandriva.com> 2.15.5-1mdv2007.0
- Release 2.15.5
- libcm 0.22
- Remove patch4 (merged upstream)

* Fri Jun 09 2006 Frederic Crozat <fcrozat@mandriva.com> 2.15.3-5mdv2007.0
- Patch4 (CVS): fix crash when no compositor is running

* Thu Jun 08 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.15.3-4
- add BuildRequires: intltool

* Tue Jun  6 2006 Gtz Waschk <waschk@mandriva.org> 2.15.3-3mdv2007.0
- fix buildrequires

* Sat Jun  3 2006 Gtz Waschk <waschk@mandriva.org> 2.15.3-2mdv2007.0
- fix buildrequires

* Thu Jun 01 2006 Frederic Crozat <fcrozat@mandriva.com> 2.15.3-1mdv2007.0
- Release 2.15.3
- Source2: add libcm 0.0.21
- Patch3: build with static libcm

* Tue May 30 2006 Götz Waschk <waschk@mandriva.org> 2.14.5-1mdk
- New release 2.14.5

* Sat Apr 15 2006 Gtz Waschk <waschk@mandriva.org> 2.14.3-1mdk
- drop merged patch 3
- New release 2.14.3

* Fri Apr 14 2006 Frederic Crozat <fcrozat@mandriva.com> 2.14.2-1mdk
- Release 2.14.2
- Remove patch3 (merged upstream)
- Patch3 (CVS): allow choosing smart or strict focus

* Thu Mar 02 2006 Frederic Crozat <fcrozat@mandriva.com> 2.12.3-3mdk
- Patch3 (Thomas Thurman): fix minimizing hidden windows (GNOME bug #315142)

* Mon Feb 27 2006 Frederic Crozat <fcrozat@mandriva.com> 2.12.3-2mdk
- Fortify preun script

* Tue Feb 07 2006 Götz Waschk <waschk@mandriva.org> 2.12.3-1mdk
- New release 2.12.3

* Tue Nov 29 2005 Götz Waschk <waschk@mandriva.org> 2.12.2-1mdk
- New release 2.12.2

* Thu Oct 06 2005 Frederic Crozat <fcrozat@mandriva.com> 2.12.1-1mdk
- Release 2.12.1
- Regenerate patch2
- Remove patches 3, 4, 5, 6, 7, 8 (merged upstream)

* Sun Aug 28 2005 Frederic Crozat <fcrozat@mandriva.com> 2.10.3-3mdk
- Patch3 (CVS): optimize gradient computation
- Patch4 (CVS): improve round corners
- Patch5 (CVS): avoid obscuring centered-on-desktop windows which are denied focus
- Patch6 (CVS): fix flicker when focusing window
- Patch7 (CVS): restore size correctly
- Patch8 (CVS): fix modal dialog stacking

* Sat Jul 30 2005 Nicolas Lcureuil <neoclust@mandriva.org> 2.10.3-2mdk
- Fix BuildRequires

* Mon Jul 25 2005 Gtz Waschk <waschk@mandriva.org> 2.10.3-1mdk
- New release 2.10.3

* Tue Jun 28 2005 Gtz Waschk <waschk@mandriva.org> 2.10.2-1mdk
- New release 2.10.2

* Wed Apr 20 2005 Frederic Crozat <fcrozat@mandriva.com> 2.10.1-1mdk 
- Release 2.10.1 (based on Gtz Waschk package)
- Remove patch3 (merged upstream)

* Mon Mar 21 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.13-2mdk 
- Patch3: activate correct window when on different workspace

* Sun Feb 20 2005 Götz Waschk <waschk@linux-mandrake.com> 2.8.13-1mdk
- New release 2.8.13

* Tue Dec  7 2004 Gtz Waschk <waschk@linux-mandrake.com> 2.8.8-1mdk
- drop patch 3
- New release 2.8.8

* Tue Oct 19 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.6-1mdk
- New release 2.8.6
- Remove patches 3, 4, 5, 6, 7, 8, 9 (merged upstream)
- Patch3 (Fedora): workaround right alt problem 

* Tue Oct 05 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-7mdk
- Update patch6 to completely fix Mdk bug #10689 when using workspace switcher

* Mon Sep 13 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-6mdk
- Update patch6 with real fix for mdk bug #11359 (Thanks to Elijah)

* Fri Sep 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-5mdk
- Patch8 (CVS): fix choice of focus window to be consistent for each mode
- Patch9 (CVS): fix race in choosing window to focus
- Regenerate patch 6 (still doesn't fix Mdk bug #11359 completely)

* Fri Sep 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-4mdk
- Update patch 6 to also fix Mdk bug #11359

* Tue Sep 07 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-3mdk
- Patch4 (CVS): choose correct window to focus when unshowing desktop
- Patch5 (CVS): don't output warning when no session manager is running
- Patch6 (CVS): fix focus when using workspace switcher (Mdk bug #10689)
- Patch7 (CVS): assume sticky windows have high priority in MRU list 

* Thu Jul 08 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.1-2mdk
- Drop patch 4 (no longer needed)
- enable libtoolize

* Wed May  5 2004 Gtz Waschk <waschk@linux-mandrake.com> 2.8.1-1mdk
- fix source URL
- New release 2.8.1

* Tue Apr 06 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.8.0-1mdk
- Release 2.8.0 (with Gtz help)

* Mon Mar  1 2004 Gtz Waschk <waschk@linux-mandrake.com> 2.6.5-2mdk
- fix buildrequires

* Mon Feb 16 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.6.5-1mdk
- Release 2.6.5
- Remove patch 5 (merged upstream)

* Mon Feb 02 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 2.6.3-2mdk
- Patch5 (CVS): various bug fixes, including one for Mdk bug #6717

* Fri Nov 07 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.6.3-1mdk
- Release 2.6.3
- Remove patch 5 (merged upstream)

* Thu Sep 25 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.6.1-2mdk
- Patch5: 64-bit fixes

* Thu Sep 11 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.6.1-1mdk
- Release 2.6.0.1

* Tue Sep 09 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.6.0-1mdk
- Release 2.6.0

* Fri Sep 05 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.5.5-1mdk
- Release 2.5.5

* Thu Sep 04 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.5.3-2mdk
- Fix BuildRequires

* Wed Jul 16 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.3-1mdk
- Release 2.5.3

* Fri Jul 11 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.2-3mdk
- Rebuild for new dependencies

* Thu Jun 12 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.2-2mdk
- Rebuild against latest ORBit2

* Mon Jun 02 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.2-1mdk
- Release 2.5.2

* Wed May 07 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.1-1mdk
- Release 2.5.1
- Remove patch5 (merged upstream)

* Tue Apr 15 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.0-2mdk
- Patch0 (CVS) : Fix gravity handling (for xmms, gkrellm, ..)

* Tue Apr 15 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.5.0-1mdk
- Release 2.5.0
- Remove patch0 (merged upstream)

* Wed Mar 12 2003 Frederic Crozat <fcrozat@mandrakesoft.com> - 2.4.34-3mdk
- Patch5 : fix Mdk bug 1961 (ksnapshot freezing desktop)

* Wed Feb 19 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.34-2mdk
- Update patch 2 to use galaxy

* Thu Feb  6 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.34-1mdk
- Release 2.4.34
- Regenerate patch2

* Tue Jan 21 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.21-1mdk
- Release 2.4.21

* Fri Jan 10 2003 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.13-1mdk
- Release 2.4.13
- Regenerate patch 4
- Remove patch6 (merged upstream)

* Tue Dec 10 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.8-1mdk
- Release 2.4.8

* Thu Nov 28 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.5-1mdk
- Release 2.4.5
- Remove patch5 (merged upstream)

* Tue Nov 19 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.3-3mdk
- Rebuild with startup-notification support
- Remove menu entry (GNOME control center has now its own dialog)
- Patch6: use Alt as default mouse button modifier

* Fri Nov  8 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.3-2mdk
- Patch5 (CVS): filter out windows that aren't in the stack 
  for whatever reason, avoiding crash

* Thu Nov  7 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.3-1mdk
- Release 2.4.3
- Regenerate patch4

* Wed Oct 30 2002 Stew Benedict <sbenedict@mandrakesoft.com> 2.4.1-4mdk
- add patch (patch4) from Gentoo folks (thx Gerk) for PPC build

* Fri Oct 11 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.1-3mdk
- Rename Bluecurve to Wonderland (don't use RH tm)

* Tue Oct  8 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.1-2mdk
- Add Bluecurve theme

* Tue Sep 10 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.1-1mdk
- Release 2.4.1 (same as previous snapshot)
- Regenerate patch0 (partially merged upstream)

* Fri Sep  6 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.0-2.20020906.1mdk
- New snapshot (fix bugs #92057, #86059)
- Update patch 2 to fix Crux theme (minor glitch on small dialog)

* Wed Aug 28 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.0-2.20020828.1mdk
- Update source to CVS snapshot (fix a lot of bugs..)
- Regenerate patches 2 & 3

* Fri Aug  9 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.0-2mdk
- Patch3: let metacity use its own font setting

* Thu Aug  8 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.4.0-1mdk
- Release 2.4.0
- Add menu entry
- Remove patches 0 & 1 (merged upstream)

* Mon Jul 24 2002 Stefan van der Eijk <stefan@eijk.nu> 2.3.987-3mdk
- BuildRequires

* Fri Jul 12 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.3.987-2mdk
- Patch1 (CVS): fix focus on new window
- Patch2: use Crux as default theme

* Mon Jun 10 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.3.987-1mdk
- Release 2.3.987
- Patch0: add Alt-F4 keybinding to close window

* Fri Jun  7 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.3.610-1mdk
- Release 2.3.610

* Mon May  6 2002 Frederic Crozat <fcrozat@mandrakesoft.com> 2.3.233-1mdk
- First Mdk package

* Thu May  2 2002 Havoc Pennington <hp@redhat.com>
- 2.3.233

* Thu Apr 25 2002 Havoc Pennington <hp@redhat.com>
- rebuild in different environment
- add gconf schemas boilerplate

* Mon Apr 15 2002 Havoc Pennington <hp@pobox.com>
- 2.3.89

* Tue Oct 30 2001 Havoc Pennington <hp@redhat.com>
- 2.3.34

* Fri Oct 13 2001 Havoc Pennington <hp@redhat.com>
- 2.3.21 

* Mon Sep 17 2001 Havoc Pennington <hp@redhat.com>
- 2.3.8
- 2.3.13

* Wed Sep  5 2001 Havoc Pennington <hp@redhat.com>
- Initial build.
